package com.iconplus.smartproc.service.approval;

import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.projection.DrpApprovalView;
import com.iconplus.smartproc.model.request.DrpApprovalRequest;
import com.iconplus.smartproc.model.response.DrpApprovalResponse;
import com.iconplus.smartproc.repository.DrpApprovalRepository;
import com.iconplus.smartproc.repository.DrpRepository;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

@Service
@Slf4j
public class GetListApprovalDrpServie implements BaseService<DrpApprovalRequest, DrpApprovalResponse> {

    private final DrpRepository drpRepository;
    private final DrpApprovalRepository drpApprovalRepository;

    public GetListApprovalDrpServie(DrpRepository drpRepository,
                                    DrpApprovalRepository drpApprovalRepository) {
        this.drpApprovalRepository = drpApprovalRepository;
        this.drpRepository = drpRepository;

    }

    @Override
    public DrpApprovalResponse execute(DrpApprovalRequest input) throws IOException {

        List<DrpApprovalResponse> drpApprovalResponseList = new ArrayList<>();
        var drpApprovalViews = drpRepository.getListApprovalDrp(input.getPageable());
        for (DrpApprovalView drpApprovalView : drpApprovalViews) {
            DrpApprovalResponse drpApprovalResponse = DrpApprovalResponse.builder()
                    .id(drpApprovalView.getId())
                    .drpId(drpApprovalView.getDrpId())
                    .tahun(drpApprovalView.getTahun())
                    .approverVpDate(drpApprovalView.getApproverVpDate())
                    .approverKomite1Date(drpApprovalView.getApproverKomite1Date())
                    .approverKomite2Date(drpApprovalView.getApproverKomite2Date())
                    .approverKomite3Date(drpApprovalView.getApproverKomite3Date())
                    .approverKomite4Date(drpApprovalView.getApproverKomite4Date())
                    .approverDirekturDate(drpApprovalView.getApproverDirekturDate())
                    .build();
        }
        return null;


    }
}
